(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      3777,        112]*)
(*NotebookOutlinePosition[      4446,        135]*)
(*  CellTagsIndexPosition[      4402,        131]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["SlotsOfTensor", "ObjectName"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["SlotsOfTensor[",
    FontFamily->"Courier"],
  StyleBox["tensor",
    FontSlant->"Italic"],
  StyleBox["]",
    FontFamily->"Courier"],
  " gives the list of vbundles with up/down marks corresponding to the slots \
of ",
  StyleBox["tensor",
    FontSlant->"Italic"],
  " as it was defined."
}], "Usage"],

Cell[TextData[{
  "\[FilledSmallSquare] Each tensor has an upvalue for this function.\n\
\[FilledSmallSquare] The slot structure is stored as ",
  StyleBox["{-M1, M1, M2, ...}",
    FontFamily->"Courier",
    FontVariations->{"CompatibilityType"->0}],
  ", such that the first slot is a covariant index on M1, the third slot is a \
contravariant index on M2, etc.\n\[FilledSmallSquare] Validation routines \
check that the up/down character of a tensor is right by comparison with ",
  StyleBox["SlotsOfTensor",
    FontFamily->"Courier"],
  ". If there is a metric on the corresponding manifold, then no error is \
given.\n\[FilledSmallSquare] Slots related by the symmetries of ",
  StyleBox["tensor",
    FontSlant->"Italic"],
  " must belong to the same vbundle and must have the same character, unless \
the option ",
  StyleBox[ButtonBox["ForceSymmetries",
    ButtonData:>{"ForceSymmetries.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  " is used.",
  "\n\[FilledSmallSquare] See: ",
  ButtonBox["Section 4.4",
    ButtonData:>{
      FrontEnd`FileName[ {
        ParentDirectory[ ]}, "xTensorRefGuide.nb", CharacterEncoding -> 
        "iso8859-1"], "Tensors"},
    ButtonStyle->"Hyperlink"],
  ".\n\[FilledSmallSquare] See also: ",
  StyleBox[ButtonBox["DefTensor",
    ButtonData:>{"DefTensor.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ".\n\[FilledSmallSquare] New in version 0.\n\[FilledSmallSquare] Last \
update: 25-IX-2007 for version 0.9.3 of ",
  StyleBox["xTensor`",
    FontFamily->"Courier"],
  "."
}], "Text"]
}, Open  ]]
},
FrontEndVersion->"5.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
WindowSize->{520, 600},
WindowMargins->{{127, Automatic}, {-81, Automatic}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 35, 0, 38, "ObjectName"],
Cell[1814, 55, 359, 13, 48, "Usage"],
Cell[2176, 70, 1585, 39, 256, "Text"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

