(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      4228,        144]*)
(*NotebookOutlinePosition[      4895,        167]*)
(*  CellTagsIndexPosition[      4851,        163]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["TransposeDagger", "ObjectName"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["TransposeDagger[",
    FontFamily->"Courier"],
  StyleBox["tensor",
    FontSlant->"Italic"],
  "[",
  StyleBox["inds",
    FontSlant->"Italic"],
  "]",
  StyleBox["]",
    FontFamily->"Courier"],
  " exchanges the position of the complex conjugated indices following this \
rule: the n-th index of the complex vbundle ",
  StyleBox["C",
    FontSlant->"Italic"],
  " is exchanged with the n-th index of the vbundle ",
  StyleBox["Dagger",
    FontFamily->"Courier"],
  "[",
  StyleBox["C",
    FontSlant->"Italic"],
  "].\n",
  "\[FilledSmallSquare] ",
  StyleBox["TransposeDagger[",
    FontFamily->"Courier"],
  StyleBox["tensor",
    FontSlant->"Italic"],
  "[",
  StyleBox["inds",
    FontSlant->"Italic"],
  "], ",
  StyleBox["vbundle",
    FontSlant->"Italic"],
  StyleBox["]",
    FontFamily->"Courier"],
  " exchanges only those indices belonging to the given ",
  StyleBox["vbundle",
    FontSlant->"Italic"],
  " and its conjugate."
}], "Usage"],

Cell[TextData[{
  "\[FilledSmallSquare] If the number of indices in ",
  StyleBox["tensor",
    FontSlant->"Italic"],
  " belonging to ",
  StyleBox["C",
    FontSlant->"Italic"],
  " and ",
  StyleBox["Dagger",
    FontFamily->"Courier"],
  "[",
  StyleBox["C",
    FontSlant->"Italic"],
  "] is not the same, an error is thrown.\n\[FilledSmallSquare] There is no \
conjugation in this process, simply swapping of indices.\n\
\[FilledSmallSquare] This is consistent both with the convention of having \
indices ",
  StyleBox["AA'BB'CC'",
    FontSlant->"Italic"],
  " or indices ",
  StyleBox["ABCA'B'C'.",
    FontSlant->"Italic"],
  "\n\[FilledSmallSquare] See: ",
  ButtonBox["Section 5.6",
    ButtonData:>{
      FrontEnd`FileName[ {
        ParentDirectory[ ]}, "xTensorRefGuide.nb", CharacterEncoding -> 
        "iso8859-1"], "Complex conjugation"},
    ButtonStyle->"Hyperlink"],
  ".\n\[FilledSmallSquare] See also: ",
  StyleBox[ButtonBox["Dagger",
    ButtonData:>{"Dagger.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ", ",
  StyleBox[ButtonBox["Hermitian",
    ButtonData:>{"Hermitian.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ".\n\[FilledSmallSquare] New in version 0.\n\[FilledSmallSquare] Last \
update: 26-X-2007 for version 0.9.3 of ",
  StyleBox["xTensor`",
    FontFamily->"Courier"],
  "."
}], "Text"]
}, Open  ]]
},
FrontEndVersion->"5.2 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
WindowSize->{520, 600},
WindowMargins->{{Automatic, 1}, {41, Automatic}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 37, 0, 38, "ObjectName"],
Cell[1816, 55, 1011, 40, 102, "Usage"],
Cell[2830, 97, 1382, 44, 200, "Text"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

